        LIST P=PIC12C509
        INCLUDE "P12C509.INC"
        __CONFIG _MCLRE_OFF & _ExtRC_OSC & _WDT_ON

ASMPL   EQU     007H 

AWMSC   EQU     010H
AWMG1   EQU     011H
AWMG2   EQU     012H
AWMG3   EQU     013H

ALMI    EQU     B'00001100'
ALMI0   EQU     B'00001100'
ALMI1   EQU     B'00001000'
ALMI2   EQU     B'00000100'
ALMI3   EQU     B'00000000'

ALMCP   EQU     B'00000001'
ALMTP   EQU     B'00000010'

ALMG1   EQU     D'4'

AMFSI   MACRO AF,AM,AV
        MOVF  AF,W
        ANDLW AM
        XORLW AV
        BTFSC STATUS,Z
        ENDM  

AMNOP4  MACRO
        NOP
        NOP
        NOP
        NOP
        ENDM

AM_STA  MACRO
MAIN
        BTFSC   STATUS,NOT_TO    ;Power on check. 
        GOTO    ALMPWON

        DECFSZ  AWMSC,F          ;Sleep count.
        SLEEP
ALMPWON
        MOVLW   B'11011111'      ;Set option register. 
        OPTION
        MOVLW   B'11111100'      ;Set I/O control.
        TRIS    GPIO

        MOVLW   ALMCP            ;Transmitter on.
        IORWF   GPIO,F
AADJ        
        CLRWDT
        AMFSI   GPIO,ALMI,ALMI0  ;Set transmit interval.
        GOTO    AADJ
        AMFSI   GPIO,ALMI,ALMI1
        CALL    AMI1
        AMFSI   GPIO,ALMI,ALMI2
        CALL    AMI2
        AMFSI   GPIO,ALMI,ALMI3
        CALL    AMI3

        BTFSC   GPIO,4           ;Set Morse coding speed.
        CALL    AMS0
        BTFSS   GPIO,4
        CALL    AMS1

        ENDM

AM_END  MACRO
        MOVLW   ALMCP            ;Transmitter off.
        XORLW   B'11111111'
        ANDWF   GPIO,F

        SLEEP

AMI1
        MOVLW   D'2'
        MOVWF   AWMSC
        RETLW   0
AMI2
        MOVLW   D'4'
        MOVWF   AWMSC
        RETLW   0
AMI3
        MOVLW   D'8'
        MOVWF   AWMSC
        RETLW   0

AMS0
        MOVLW   D'16'
        MOVWF   ASMPL
        MOVLW   D'4'             ;Transmission delay.
        CALL    AMMGW
        RETLW   0
AMS1
        MOVLW   D'8'
        MOVWF   ASMPL
        MOVLW   D'8'             ;Transmission delay.
        CALL    AMMGW
        RETLW   0

ASDOT    
        MOVLW   D'1'
        CALL    AMMGT
        MOVLW   D'1'
        CALL    AMMGW
        RETLW   0

ASDAS    
        MOVLW   D'3'
        CALL    AMMGT
        MOVLW   D'1'
        CALL    AMMGW
        RETLW   0

ASWS2    
        MOVLW   D'2'
        CALL    AMMGW
        RETLW   0

ASWS6    
        MOVLW   D'6'
        CALL    AMMGW
        RETLW   0

AMMGT
        MOVWF   AWMG3
        MOVF    ASMPL,W
        MOVWF   AWMG2
        MOVLW   ALMG1
        MOVWF   AWMG1
AMMGTL1
        AMNOP4
AMMGTL2
        AMNOP4
AMMGTL3
        MOVLW   ALMTP
        IORWF   GPIO,F
        AMNOP4
        AMNOP4
        NOP
        CLRWDT
        MOVLW   ALMTP
        XORLW   B'11111111'
        ANDWF   GPIO,F
        DECFSZ  AWMG1,F
        GOTO    AMMGTL1
        MOVLW   ALMG1
        MOVWF   AWMG1
        DECFSZ  AWMG2,F
        GOTO    AMMGTL2
        MOVF    ASMPL,W
        MOVWF   AWMG2
        DECFSZ  AWMG3,F
        GOTO    AMMGTL3
        RETLW   0

AMMGW
        MOVWF   AWMG3
        MOVF    ASMPL,W
        MOVWF   AWMG2
        MOVLW   ALMG1
        MOVWF   AWMG1
AMMGWL1
        AMNOP4
AMMGWL2
        AMNOP4
AMMGWL3
        MOVLW   ALMTP
        NOP
        AMNOP4
        AMNOP4
        NOP
        CLRWDT
        MOVLW   ALMTP
        XORLW   B'11111111'
        NOP
        DECFSZ  AWMG1,F
        GOTO    AMMGWL1
        MOVLW   ALMG1
        MOVWF   AWMG1
        DECFSZ  AWMG2,F
        GOTO    AMMGWL2
        MOVF    ASMPL,W
        MOVWF   AWMG2
        DECFSZ  AWMG3,F
        GOTO    AMMGWL3
        RETLW   0
        ENDM

ADOT    MACRO
        CALL    ASDOT
        ENDM

ADAS    MACRO
        CALL    ASDAS
        ENDM

AWS2    MACRO
        CALL    ASWS2
        ENDM

AWS6    MACRO
        CALL    ASWS6
        ENDM

AM_A    MACRO
        ADOT
        ADAS
        AWS2
        ENDM

AM_B    MACRO
        ADAS
        ADOT
        ADOT
        ADOT
        AWS2
        ENDM

AM_C    MACRO
        ADAS
        ADOT
        ADAS
        ADOT
        AWS2
        ENDM

AM_D    MACRO
        ADAS
        ADOT
        ADOT
        AWS2
        ENDM

AM_E    MACRO
        ADOT
        AWS2
        ENDM

AM_F    MACRO
        ADOT
        ADOT
        ADAS
        ADOT
        AWS2
        ENDM

AM_G    MACRO
        ADAS
        ADAS
        ADOT
        AWS2
        ENDM

AM_H    MACRO
        ADOT
        ADOT
        ADOT
        ADOT
        AWS2
        ENDM

AM_I    MACRO
        ADOT
        ADOT
        AWS2
        ENDM

AM_J    MACRO
        ADOT
        ADAS
        ADAS
        ADAS
        AWS2
        ENDM

AM_K    MACRO
        ADAS
        ADOT
        ADAS
        AWS2
        ENDM

AM_L    MACRO
        ADOT
        ADAS
        ADOT
        ADOT
        AWS2
        ENDM

AM_M    MACRO
        ADAS
        ADAS
        AWS2
        ENDM

AM_N    MACRO
        ADAS
        ADOT
        AWS2
        ENDM

AM_O    MACRO
        ADAS
        ADAS
        ADAS
        AWS2
        ENDM

AM_P    MACRO
        ADOT
        ADAS
        ADAS
        ADOT
        AWS2
        ENDM

AM_Q    MACRO
        ADAS
        ADAS
        ADOT
        ADAS
        AWS2
        ENDM

AM_R    MACRO
        ADOT
        ADAS
        ADOT
        AWS2
        ENDM

AM_S    MACRO
        ADOT
        ADOT
        ADOT
        AWS2
        ENDM

AM_T    MACRO
        ADAS
        AWS2
        ENDM

AM_U    MACRO
        ADOT
        ADOT
        ADAS
        AWS2
        ENDM

AM_V    MACRO
        ADOT
        ADOT
        ADOT
        ADAS
        AWS2
        ENDM

AM_W    MACRO
        ADOT
        ADAS
        ADAS
        AWS2
        ENDM

AM_X    MACRO
        ADAS
        ADOT
        ADOT
        ADAS
        AWS2
        ENDM

AM_Y    MACRO
        ADAS
        ADOT
        ADAS
        ADAS
        AWS2
        ENDM

AM_Z    MACRO
        ADAS
        ADAS
        ADOT
        ADOT
        AWS2
        ENDM

AM_1    MACRO
        ADOT
        ADAS
        ADAS
        ADAS
        ADAS
        AWS2
        ENDM

AM_2    MACRO
        ADOT
        ADOT
        ADAS
        ADAS
        ADAS
        AWS2
        ENDM

AM_3    MACRO
        ADOT
        ADOT
        ADOT
        ADAS
        ADAS
        AWS2
        ENDM

AM_4    MACRO
        ADOT
        ADOT
        ADOT
        ADOT
        ADAS
        AWS2
        ENDM

AM_5    MACRO
        ADOT
        ADOT
        ADOT
        ADOT
        ADOT
        AWS2
        ENDM

AM_6    MACRO
        ADAS
        ADOT
        ADOT
        ADOT
        ADOT
        AWS2
        ENDM

AM_7    MACRO
        ADAS
        ADAS
        ADOT
        ADOT
        ADOT
        AWS2
        ENDM

AM_8    MACRO
        ADAS
        ADAS
        ADAS
        ADOT
        ADOT
        AWS2
        ENDM

AM_9    MACRO
        ADAS
        ADAS
        ADAS
        ADAS
        ADOT
        AWS2
        ENDM

AM_0    MACRO
        ADAS
        ADAS
        ADAS
        ADAS
        ADAS
        AWS2
        ENDM

AM_PER  MACRO ; .
        ADOT
        ADAS
        ADOT
        ADAS
        ADOT
        ADAS
        AWS2
        ENDM

AM_COM  MACRO ; ,
        ADAS
        ADAS
        ADOT
        ADOT
        ADAS
        ADAS
        AWS2
        ENDM

AM_COL  MACRO ; :
        ADAS
        ADAS
        ADAS
        ADOT
        ADOT
        ADOT
        AWS2
        ENDM

AM_QUE  MACRO ; ?
        ADOT
        ADOT
        ADAS
        ADAS
        ADOT
        ADOT
        AWS2
        ENDM

AM_DAS  MACRO ; '
        ADOT
        ADAS
        ADAS
        ADAS
        ADAS
        ADOT
        AWS2
        ENDM

AM_HYP  MACRO ; -
        ADAS
        ADOT
        ADOT
        ADOT
        ADOT
        ADAS
        AWS2
        ENDM

AM_LBR  MACRO ; (
        ADAS
        ADOT
        ADAS
        ADAS
        ADOT
        AWS2
        ENDM

AM_RBR  MACRO ; )
        ADAS
        ADOT
        ADAS
        ADAS
        ADOT
        ADAS
        AWS2
        ENDM

AM_SLA  MACRO ; /
        ADAS
        ADOT
        ADOT
        ADAS
        ADOT
        AWS2
        ENDM

AM_EQU  MACRO ; =
        ADAS
        ADOT
        ADOT
        ADOT
        ADAS
        AWS2
        ENDM

AM_PLU  MACRO ; +
        ADOT
        ADAS
        ADAT
        ADAS
        ADOT
        AWS2
        ENDM

AM_QUO  MACRO ; "
        ADOT
        ADAS
        ADOT
        ADOT
        ADAS
        ADOT
        AWS2
        ENDM

